diff -ruN freeswan-1.5.orig/pluto/openssl.h freeswan-1.5/pluto/openssl.h
--- freeswan-1.5.orig/pluto/openssl.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.5/pluto/openssl.h	Thu Oct  5 07:05:59 2000
@@ -0,0 +1,87 @@
+#ifdef OPENSSL
+#ifndef OPENSSL_INC_H
+#define OPENSSL_INC_H
+
+#include <openssl/evp.h>
+#include <openssl/err.h>
+#include <openssl/pem.h>
+#include <openssl/x509.h>
+#include <openssl/x509v3.h>
+#include <openssl/safestack.h>
+
+#include <freeswan.h>
+
+#include "xmap.h"
+
+struct _x509_cert_node {
+  X509 *x;
+  struct _x509_cert_node *next;
+};
+
+typedef struct _x509_cert_node *X509_cert_list;
+
+typedef bool discrim_fn( X509 *x, STACK_OF(XMAP) *lu,
+			 struct payload_digest *const id_pld, bool strict);
+
+extern void make_lookups(STACK_OF(XMAP) **lu, const char *spec );
+extern void log_err( void );
+extern void load_cert_and_key( const char *cert, const char *key,
+			       X509 **x, EVP_PKEY **k );
+extern bool use_openssl( struct connection *c );
+extern STACK_OF(X509) *
+peer_cert_list( STACK_OF(XMAP) *lu,
+		int type,
+		X509 *cert, struct payload_digest *const id_pld,
+		bool strict );
+
+extern bool have_rsa_key( struct state *st );
+extern bool have_dss_key( struct state *st );
+extern bool have_rsa_keypair( struct state *st );
+extern bool have_elgamal_keypair( struct state *st );
+
+extern bool verify_certificate( X509 *x, STACK_OF(XMAP) *lu,
+				const char *path, bool strict );
+
+extern u_int32_t parse_options( const char *s );
+
+extern int DSA_sign_raw(unsigned char *dgst,int dlen,
+			unsigned char *sig, unsigned int *siglen, DSA *dsa);
+
+extern int DSA_verify_raw(const unsigned char *dgst,int dgst_len,
+			  unsigned char *sigbuf, int siglen, DSA *dsa);
+
+#define ERR_LIB_ELGAMAL 127
+
+#define ELGAMAL_F_ELGAMAL_PRIVATE_DECRYPT 100
+#define ELGAMAL_F_ELGAMAL_PUBLIC_ENCRYPT  101
+
+#define ELGAMAL_R_UNKNOWN_PADDING_TYPE      100
+#define ELGAMAL_R_DATA_GREATER_THAN_MOD_LEN 101
+#define ELGAMAL_R_PADDING_CHECK_FAILED      102
+
+#define ELGAMAL_PKCS1_PADDING RSA_PKCS1_PADDING
+#define ELGAMAL_PKCS1_OAEP_PADDING RSA_PKCS1_OAEP_PADDING
+#define ELGAMAL_NO_PADDING RSA_NO_PADDING
+
+#define ElGamalerr(f, r) ERR_PUT_error(ERR_LIB_ELGAMAL, (f), (r), ERR_file_name, __LINE__)
+
+void ERR_load_ElGamal_strings( void );
+int ElGamal_public_check( DSA *dsa );
+int ElGamal_public_encrypt( int flen, unsigned char *from,
+			    unsigned char *to,
+			    DSA *dsa, int padding );
+int ElGamal_private_decrypt( int flen, unsigned char *from,
+			     unsigned char *to,
+			     DSA *dsa, int padding );
+
+/* Function pointer pointing to an encryption routine */
+typedef void encryptor_fn( chunk_t *ch, struct state *c );
+
+extern bool valid_ciphertext_length( const u_int32_t len,
+				     struct connection *c );
+extern encryptor_fn pubkey_encrypt_chunk, privkey_decrypt_chunk;
+
+#endif
+#endif
+
+
diff -ruN freeswan-1.5.orig/pluto/openssl_defs.h freeswan-1.5/pluto/openssl_defs.h
--- freeswan-1.5.orig/pluto/openssl_defs.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.5/pluto/openssl_defs.h	Thu Oct  5 07:05:59 2000
@@ -0,0 +1,5 @@
+
+#define FILE_NAME_LIMIT 80
+#define PATH_NAME_LIMIT 256
+#define CERT_OPTIONS_LIMIT 128
+#define MAX_OTHER 2 /* only know about two type of certificate at the moment (RSA,DSA) */
diff -ruN freeswan-1.5.orig/pluto/spdb.c freeswan-1.5/pluto/spdb.c
--- freeswan-1.5.orig/pluto/spdb.c	Wed Jun 21 14:24:35 2000
+++ freeswan-1.5/pluto/spdb.c	Thu Oct  5 07:05:59 2000
@@ -39,6 +39,11 @@
 #include "md5.h"
 #include "crypto.h" /* requires sha1.h and md5.h */
 
+#ifdef OPENSSL
+#include "demux.h"
+#include "openssl.h"
+#endif
+
 #define AD(x) x, elemsof(x)	/* Array Description */
 
 /**************** Oakely (main mode) SA database ****************/
@@ -103,6 +108,86 @@
 	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
 	};
 
+#ifdef OPENSSL /* !OPENSSL */
+
+static struct db_attr ot1024des3md5_ds_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024des3sha_ds_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024des3sha_ds_dss[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_DSS_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024des3md5_pk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024des3sha_pk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024des3sha_pk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024des3md5_pk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024des3md5_rpk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024des3sha_rpk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024des3sha_rpk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024des3md5_rpk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+#endif /* OPENSSL */
+
 /* We won't accept this, but by proposing it, we get to test
  * our rejection.  We better not propose it to an IKE daemon
  * that will accept it!
@@ -118,6 +203,7 @@
 
 /* tables of transforms, in preference order (select based on AUTH) */
 
+
 static struct db_trans oakley_trans_psk[] = {
 #ifdef TEST_INDECENT_PROPOSAL
 	{ KEY_IKE, AD(otpsk1024des3tiger) },
@@ -152,6 +238,53 @@
 	{ KEY_IKE, AD(otpsk768des3sha) },
     };
 
+#ifdef OPENSSL
+
+static struct db_trans oakley_trans_psk2[] = {
+#ifdef TEST_INDECENT_PROPOSAL
+	{ KEY_IKE, AD(otpsk1024des3tiger), NULL },
+#endif
+	{ KEY_IKE, AD(otpsk1024des3sha), NULL },
+	{ KEY_IKE, AD(otpsk1024des3md5), NULL },
+	{ KEY_IKE, AD(otpsk768des3md5), NULL },
+	{ KEY_IKE, AD(otpsk768des3sha), NULL },
+    };
+
+static struct db_trans oakley_trans_openssl[] = {
+  { KEY_IKE, AD(ot1024des3sha_rpk_elgamal), have_elgamal_keypair },
+  { KEY_IKE, AD(ot1024des3sha_rpk_rsa), have_rsa_keypair },
+  { KEY_IKE, AD(ot1024des3md5_rpk_elgamal), have_elgamal_keypair },
+  { KEY_IKE, AD(ot1024des3md5_rpk_rsa), have_rsa_keypair },
+  { KEY_IKE, AD(ot1024des3sha_pk_elgamal), have_elgamal_keypair },
+  { KEY_IKE, AD(ot1024des3sha_pk_rsa), have_rsa_keypair },
+  { KEY_IKE, AD(ot1024des3md5_pk_elgamal), have_elgamal_keypair },
+  { KEY_IKE, AD(ot1024des3md5_pk_rsa), have_rsa_keypair },
+  { KEY_IKE, AD(ot1024des3sha_ds_dss), have_dss_key },
+  { KEY_IKE, AD(ot1024des3sha_ds_rsa), have_rsa_key },
+  { KEY_IKE, AD(ot1024des3md5_ds_rsa), have_rsa_key },
+  };
+
+static struct db_trans oakley_trans_psk2openssl[] = {
+  { KEY_IKE, AD(ot1024des3sha_rpk_elgamal), have_elgamal_keypair },
+  { KEY_IKE, AD(ot1024des3sha_rpk_rsa), have_rsa_keypair },
+  { KEY_IKE, AD(ot1024des3md5_rpk_elgamal), have_elgamal_keypair },
+  { KEY_IKE, AD(ot1024des3md5_rpk_rsa), have_rsa_keypair },
+  { KEY_IKE, AD(ot1024des3sha_pk_elgamal), have_elgamal_keypair },
+  { KEY_IKE, AD(ot1024des3sha_pk_rsa), have_rsa_keypair },
+  { KEY_IKE, AD(ot1024des3md5_pk_elgamal), have_elgamal_keypair },
+  { KEY_IKE, AD(ot1024des3md5_pk_rsa), have_rsa_keypair },
+  { KEY_IKE, AD(ot1024des3sha_ds_dss), have_dss_key },
+  { KEY_IKE, AD(ot1024des3sha_ds_rsa), have_rsa_key },
+  { KEY_IKE, AD(ot1024des3md5_ds_rsa), have_rsa_key },
+  { KEY_IKE, AD(otpsk1024des3sha), NULL },
+  { KEY_IKE, AD(otpsk1024des3md5), NULL },
+  { KEY_IKE, AD(otpsk768des3md5), NULL },
+  { KEY_IKE, AD(otpsk768des3sha), NULL },
+  };
+#endif
+
+
+
 /* array of proposals to be conjoined (can only be one for Oakley) */
 
 static struct db_prop oakley_pc_psk[] =
@@ -163,6 +296,17 @@
 static struct db_prop oakley_pc_pskrsasig[] =
     { { PROTO_ISAKMP, AD(oakley_trans_pskrsasig) } };
 
+#ifdef OPENSSL
+static struct db_prop oakley_pc_psk2[] =
+    { { PROTO_ISAKMP, AD(oakley_trans_psk2) } };
+
+static struct db_prop oakley_pc_openssl[] =
+    { { PROTO_ISAKMP, AD(oakley_trans_openssl) } };
+
+static struct db_prop oakley_pc_psk2openssl[] =
+    { { PROTO_ISAKMP, AD(oakley_trans_psk2openssl) } };
+#endif
+
 /* array of proposal conjuncts (can only be one) */
 
 static struct db_prop_conj oakley_props_psk[] = { { AD(oakley_pc_psk) } };
@@ -171,6 +315,14 @@
 
 static struct db_prop_conj oakley_props_pskrsasig[] = { { AD(oakley_pc_pskrsasig) } };
 
+#ifdef OPENSSL
+static struct db_prop_conj oakley_props_psk2[] = { { AD(oakley_pc_psk2) } };
+
+static struct db_prop_conj oakley_props_openssl[] = { { AD(oakley_pc_openssl) } };
+
+static struct db_prop_conj oakley_props_psk2openssl[] = { { AD(oakley_pc_psk2openssl) } };
+#endif
+
 /* the sadb entry, subscripted by POLICY_PSK and POLICY_RSASIG bits */
 struct db_sa oakley_sadb[] = {
     { NULL, 0 },	/* none */
@@ -179,6 +331,16 @@
     { AD(oakley_props_pskrsasig) },	/* POLICY_PSK + POLICY_RSASIG */
     };
 
+#ifdef OPENSSL
+/* the sadb entry, subscripted by POLICY_PSK and POLICY_OPENSSL bits */
+struct db_sa oakley_sadb2[] = {
+    { NULL, 0 },	/* none */
+    { AD(oakley_props_psk2) },	/* POLICY_PSK */
+    { AD(oakley_props_openssl) },	/* POLICY_OPENSSL */
+    { AD(oakley_props_psk2openssl) },	/* POLICY_PSK + POLICY_OPENSSL */
+    };
+#endif
+
 /**************** IPsec (quick mode) SA database ****************/
 
 /* arrays of attributes for transforms */
@@ -234,27 +396,51 @@
 /* arrays of transforms, each in in preference order */
 
 static struct db_trans espa_trans_tunnel[] = {
+#ifndef OPENSSL
     { ESP_3DES, AD(espmd5_attr_tunnel) },
     { ESP_3DES, AD(espsha1_attr_tunnel) },
+#else
+    { ESP_3DES, AD(espmd5_attr_tunnel), NULL },
+    { ESP_3DES, AD(espsha1_attr_tunnel), NULL },
+#endif
     };
 
 static struct db_trans espa_trans_transport[] = {
+#ifndef OPENSSL
     { ESP_3DES, AD(espmd5_attr_transport) },
     { ESP_3DES, AD(espsha1_attr_transport) },
+#else
+    { ESP_3DES, AD(espmd5_attr_transport), NULL },
+    { ESP_3DES, AD(espsha1_attr_transport), NULL },
+#endif
     };
 
 static struct db_trans esp_trans_tunnel[] = {
+#ifndef OPENSSL
     { ESP_3DES, AD(esp_attr_tunnel) },
+#else
+    { ESP_3DES, AD(esp_attr_tunnel), NULL },
+#endif
     };
 
 static struct db_trans esp_trans_transport[] = {
+#ifndef OPENSSL
     { ESP_3DES, AD(esp_attr_transport) },
+#else
+    { ESP_3DES, AD(esp_attr_transport), NULL },
+#endif
     };
 
 #ifdef SUPPORT_ESP_NULL
 static struct db_trans espnull_trans_tunnel[] = {
+#ifndef OPENSSL
     { ESP_NULL, AD(espmd5_attr_tunnel) },
     { ESP_NULL, AD(espsha1_attr_tunnel) },
+#else
+    { ESP_NULL, AD(espmd5_attr_tunnel), NULL },
+    { ESP_NULL, AD(espsha1_attr_tunnel), NULL },
+#endif
+
     };
 
 static struct db_trans espnull_trans_transport[] = {
@@ -264,13 +450,23 @@
 #endif /* SUPPORT_ESP_NULL */
 
 static struct db_trans ah_trans_tunnel[] = {
+#ifndef OPENSSL
     { AH_MD5, AD(ah_HMAC_MD5_attr_tunnel) },
     { AH_SHA, AD(ah_HMAC_SHA1_attr_tunnel) },
+#else
+    { AH_MD5, AD(ah_HMAC_MD5_attr_tunnel), NULL },
+    { AH_MD5, AD(ah_HMAC_SHA1_attr_tunnel), NULL },
+#endif
     };
 
 static struct db_trans ah_trans_transport[] = {
+#ifndef OPENSSL
     { AH_MD5, AD(ah_HMAC_MD5_attr_transport) },
     { AH_SHA, AD(ah_HMAC_SHA1_attr_transport) },
+#else
+    { AH_MD5, AD(ah_HMAC_MD5_attr_transport), NULL },
+    { AH_MD5, AD(ah_HMAC_SHA1_attr_transport), NULL },
+#endif
     };
 
 /* arrays of proposals to be conjoined */
@@ -464,7 +660,18 @@
 	    proposal.isap_proposal = pcn;
 	    proposal.isap_protoid = p->protoid;
 	    proposal.isap_spisize = oakley_mode? 0 : IPSEC_DOI_SPI_SIZE;
+#ifndef OPENSSL
 	    proposal.isap_notrans = p->trans_cnt;
+#else
+	    proposal.isap_notrans = 0;
+	    for(tn = 0; tn < p->trans_cnt; tn++) {
+	      struct db_trans *t = &(p->trans[tn]);
+	      if (t->offer == NULL)
+		proposal.isap_notrans++;
+	      else if ((t->offer(st))) /* only offer a propsal if we can carry it out */
+		proposal.isap_notrans++;
+	    }
+#endif
 	    if (!out_struct(&proposal, &isakmp_proposal_desc, &sa_pbs, &proposal_pbs))
 		return FALSE;
 
@@ -537,6 +744,14 @@
 
 		trans.isat_np = (tn == p->trans_cnt - 1)
 		    ? ISAKMP_NEXT_NONE : ISAKMP_NEXT_T;
+#ifdef OPENSSL
+		if ((t->offer != NULL) && ((t->offer)(st) == FALSE)) {
+		  DBG(DBG_PARSING,
+		  DBG_log("Skipping unavailable cipher: %d", tn);
+		  );
+		  continue; /* skip unavailable cipher */
+		}
+#endif
 		trans.isat_transnum = tn;
 		trans.isat_transid = t->transid;
 		if (!out_struct(&trans, trans_desc, &proposal_pbs, &trans_pbs))
@@ -629,6 +844,180 @@
     return val;
 }
 
+#ifdef OPENSSL
+struct _trans_node {
+  struct oakley_trans_attrs ta;
+  struct isakmp_transform trans;
+  u_char *attr_start;
+  size_t attr_len;
+  bool elim; /* has this node been eliminated from the selection process */
+  struct _trans_node *next;
+};
+
+typedef struct _trans_node *trans_list;
+
+/* Free a list of Oakley transforms */
+static void
+trans_list_free( trans_list *l )
+{
+  trans_list p;
+
+  if (!l) return;
+  while (*l) {
+    p = *l;
+    *l = p->next;
+    pfree(p->attr_start);
+    pfree(p);
+  }
+}
+
+static void
+trans_list_append(trans_list *l,
+		  struct oakley_trans_attrs *ta,
+		  struct isakmp_transform *trans,
+		  u_char *attr_start,
+		  size_t attr_len) {
+  trans_list p, pp;
+
+  if (!l) return;
+  if ((p = alloc_bytes(sizeof(struct _trans_node),
+		       "transformation node")) == NULL) return;
+  p->ta = *ta;
+  p->trans = *trans;
+  p->attr_len = attr_len;
+  if ((p->attr_start = alloc_bytes(attr_len, "attribute")) == NULL) {
+    pfree(p);
+    return;
+  }
+  memcpy(p->attr_start, attr_start, attr_len);
+  p->elim = FALSE;
+  p->next = NULL;
+  if (*l == NULL) {
+    *l = p;
+  } else {
+    for(pp = *l; pp->next ; pp = pp->next);
+    pp->next = p;
+  }
+}
+
+static bool
+select_trans_candidate(trans_list l,
+		       struct oakley_trans_attrs *ta,
+		       struct isakmp_transform *trans,
+		       u_char **attr_start,
+		       size_t *attr_len,
+		       u_int32_t opts)
+{
+  bool ret = FALSE;
+  trans_list auth[OAKLEY_ELGAMAL_ENC_REV+1], p;
+  uint i, numprefs, pref[10];
+
+  if (!l) {
+	DBG(DBG_PARSING,
+    DBG_log("No candidate transforms to choose from");
+	);
+    return FALSE;
+  }
+
+  if ((!ta) || (!attr_len) || (!trans) || (!attr_start)) {
+	DBG(DBG_PARSING,
+    DBG_log("No space to store selected transform");
+	);
+    return FALSE;
+  }
+
+  /* Separate all elements of the list by authentication method */
+
+  for(i=OAKLEY_PRESHARED_KEY; i<=OAKLEY_ELGAMAL_ENC_REV; i++)
+    auth[i] = NULL;
+  for(p=l; p; p=p->next)
+    if ((p->ta.auth >= OAKLEY_PRESHARED_KEY) &&
+	(p->ta.auth <= OAKLEY_ELGAMAL_ENC_REV )) {
+      trans_list_append(&(auth[p->ta.auth]),
+			&(p->ta),
+			&(p->trans),
+			p->attr_start,
+			p->attr_len);
+    }
+
+  numprefs = 7;
+  pref[numprefs-1] = OAKLEY_PRESHARED_KEY;
+  DBG(DBG_PARSING | DBG_CRYPT,
+  DBG_log("select_trans_candidate: %08x", opts);
+  );
+  if (opts & CERT_OPTION_PK) {
+    if (opts & CERT_OPTION_REV) {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring revised PK encryption schemes");
+      );
+      pref[0] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[1] = OAKLEY_RSA_ENC_REV;
+      pref[2] = OAKLEY_ELGAMAL_ENC;
+      pref[3] = OAKLEY_RSA_ENC;
+      pref[4] = OAKLEY_RSA_SIG;
+      pref[5] = OAKLEY_DSS_SIG;
+    } else {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring standard PK encryption schemes");
+      );
+      pref[0] = OAKLEY_ELGAMAL_ENC;
+      pref[1] = OAKLEY_RSA_ENC;
+      pref[2] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[3] = OAKLEY_RSA_ENC_REV;
+      pref[4] = OAKLEY_RSA_SIG;
+      pref[5] = OAKLEY_DSS_SIG;
+    }
+  } else {
+    if (opts & CERT_OPTION_REV) {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring digisig schemes, then revised pk");
+      );
+      pref[0] = OAKLEY_RSA_SIG;
+      pref[1] = OAKLEY_DSS_SIG;
+      pref[2] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[3] = OAKLEY_RSA_ENC_REV;
+      pref[4] = OAKLEY_ELGAMAL_ENC;
+      pref[5] = OAKLEY_RSA_ENC;
+    } else {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring digisig schemes, then standard pk");
+      );
+      pref[0] = OAKLEY_RSA_SIG;
+      pref[1] = OAKLEY_DSS_SIG;
+      pref[2] = OAKLEY_ELGAMAL_ENC;
+      pref[3] = OAKLEY_RSA_ENC;
+      pref[4] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[5] = OAKLEY_RSA_ENC_REV;
+    }
+  }
+
+  for(i=0; ((i<numprefs) && (!ret)); i++) {
+    DBG(DBG_PARSING,
+    DBG_log("Trying out: %s", enum_show(&oakley_auth_names, pref[i]));
+    );
+    if ((pref[i]) && (auth[pref[i]])) {
+      ret = TRUE;
+      *ta = auth[pref[i]]->ta;
+      *trans = auth[pref[i]]->trans;
+      *attr_start = alloc_bytes(auth[pref[i]]->attr_len, "attribute");
+      if (*attr_start) {
+	*attr_len = auth[pref[i]]->attr_len;
+	memcpy(*attr_start, auth[pref[i]]->attr_start, *attr_len);
+      }
+      DBG(DBG_PARSING,
+      DBG_log("Candidate selected: %s", 
+        enum_show(&oakley_auth_names, pref[i]));
+      );
+    }
+}
+  
+  for(i=OAKLEY_PRESHARED_KEY; i<=OAKLEY_RSA_ENC_REV; i++) {
+    trans_list_free(&auth[i]);
+  }
+  return ret;
+}
+#endif
+
 /* Parse the body of an ISAKMP SA Payload (i.e. Phase 1 / Main Mode).
  * Various shortcuts are taken.  In particular, the policy, such as
  * it is, is hardwired.
@@ -658,6 +1047,10 @@
     struct isakmp_proposal proposal;
     unsigned no_trans_left;
     int last_transnum;
+#ifdef OPENSSL
+    bool selected;
+    trans_list tl = NULL;
+#endif
 
     /* DOI */
     if (sa->isasa_doi != ISAKMP_DOI_IPSEC)
@@ -893,10 +1286,48 @@
 				, "policy does not allow OAKLEY_PRESHARED_KEY authentication");
 			}
 			break;
+#ifdef OPENSSL
+		    case OAKLEY_DSS_SIG:
+		      if ((st->st_connection->key == NULL) ||
+			  (((EVP_PKEY *)(st->st_connection->key))->type != EVP_PKEY_DSA))
+			snprintf(ugh, sizeof(ugh), "OAKLEY_DSS_SIG requested, but no DSA key available to sign with");
+		      ta.auth = val;
+		      break;
+//		    case OAKLEY_RSA_SIG:
+		    case OAKLEY_RSA_ENC:
+		      if (!have_rsa_keypair(st))
+			snprintf(ugh, sizeof(ugh), "OAKLEY_RSA_ENC requested, but no cert available to encrypt with");
+		      ta.auth = val;
+		      break;
+		    case OAKLEY_ELGAMAL_ENC:
+		      if (!have_elgamal_keypair(st))
+			snprintf(ugh, sizeof(ugh), "OAKLEY_ELGAMAL_ENC requested, but no cert available to encrypt with");
+		      ta.auth = val;
+		      break;
+		    case OAKLEY_RSA_ENC_REV:
+		      if (!have_rsa_keypair(st))
+			snprintf(ugh, sizeof(ugh), "OAKLEY_RSA_ENC_REV requested, but no cert available to encrypt with");
+		      ta.auth = val;
+		      break;
+		    case OAKLEY_ELGAMAL_ENC_REV:
+		      if (!have_elgamal_keypair(st))
+			snprintf(ugh, sizeof(ugh), "OAKLEY_ELGAMAL_ENC_REV requested, but no cert available to encrypt with");
+		      ta.auth = val;
+		      break;
+#endif /* ! OPENSSL */
+
 #ifndef NO_RSA	/* if this is defined, don't accept OAKLEY_RSA_SIG */
+#ifdef OPENSSL
+if (!use_openssl(st->st_connection)) 
+{
+#endif /* OPENSSL, !use_openssl */
 		    case OAKLEY_RSA_SIG:
-			/* Accept if policy specifies RSASIG or is default */
+			/* Accept if policy specifies RSASIG/OPENSSL or is default */
+#ifndef OPENSSL
 			if ((st->st_policy & POLICY_RSASIG)
+#else
+			if ((st->st_policy & POLICY_OPENSSL)
+#endif /* OPENSSL */
 			|| (st->st_policy & POLICY_ISAKMP_MASK) == LEMPTY)
 			{
 			    /* We'd like to check that we can find a public
@@ -915,7 +1346,19 @@
 				, "policy does not allow OAKLEY_RSA_SIG authentication");
 			}
 			break;
-#endif
+#ifdef OPENSSL
+}
+else /* use_openssl */
+{
+		      if ((st->st_connection->key == NULL) ||
+			  (((EVP_PKEY *)(st->st_connection->key))->type != EVP_PKEY_RSA))
+			snprintf(ugh, sizeof(ugh), "OAKLEY_RSA_SIG requested, but no key available to sign with");
+		      ta.auth = val;
+		      break;
+}
+#endif /* OPENSSL, use_openssl */
+#endif /* NO_RSA */
+
 		    default:
 			snprintf(ugh, sizeof(ugh)
 			    , "Pluto does not support %s authentication"
@@ -1030,6 +1473,15 @@
 	     * Lets finish early and leave.
 	     */
 
+#ifdef OPENSSL
+	    /*
+	     * Alternatively, we like this transform, so push it into
+	     * a list of potential winners, and rely on the site policy
+	     * to pick which of the candidates should be chosen
+	     */
+#endif
+
+#ifndef OPENSSL
 	    DBG(DBG_PARSING | DBG_CRYPT,
 		DBG_log("Oakley Transform %u accepted", trans.isat_transnum));
 
@@ -1083,6 +1535,14 @@
 	    /* copy over the results */
 	    st->st_oakley = ta;
 	    return NOTHING_WRONG;
+#else
+	    /*
+	     * We store the ta result into the list of candidates
+	     * Afterwards, site policy dictates which of the
+	     * candidates we should select
+	     */
+	    trans_list_append(&tl, &ta, &trans, attr_start, attr_len);
+#endif
 	}
 
 	/* on to next transform */
@@ -1104,8 +1564,73 @@
 	    return BAD_PROPOSAL_SYNTAX;
 	}
     }
+#ifndef OPENSSL
     loglog(RC_LOG_SERIOUS, "no acceptable Oakley Transform");
     return NO_PROPOSAL_CHOSEN;
+#else
+    /* We should have a list of hopefuls in the list tl */
+    {
+      u_char *attr_start;
+      size_t attr_len;
+      struct isakmp_transform trans;
+
+      selected = select_trans_candidate(tl, &st->st_oakley, &trans, &attr_start, &attr_len, st->st_connection->cert_options);
+      trans_list_free(&tl);
+      if (! selected) {
+  log("no acceptable Oakley Transform");
+  return NO_PROPOSAL_CHOSEN;
+      } else {
+  DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Oakley Transform %u accepted", trans.isat_transnum));
+
+  if (r_sa_pbs != NULL)
+    {
+      struct isakmp_proposal r_proposal = proposal;
+      pb_stream r_proposal_pbs;
+      struct isakmp_transform r_trans = trans;
+      pb_stream r_trans_pbs;
+
+      /* Situation */
+      if (!out_struct(&ipsecdoisit, &ipsec_sit_desc, r_sa_pbs, NULL))
+        passert(FALSE);
+
+      /* Proposal */
+#ifdef EMIT_ISAKMP_SPI
+      r_proposal.isap_spisize = COOKIE_SIZE;
+#else
+      r_proposal.isap_spisize = 0;
+#endif
+      r_proposal.isap_notrans = 1;
+      if (!out_struct(&r_proposal, &isakmp_proposal_desc, r_sa_pbs, &r_proposal_pbs))
+        passert(FALSE);
+
+      /* SPI */
+#ifdef EMIT_ISAKMP_SPI
+      if (!out_raw(my_cookie, COOKIE_SIZE, &r_proposal_pbs, "SPI"))
+        passert(FALSE);
+      r_proposal.isap_spisize = COOKIE_SIZE;
+#else
+      /* none (0) */
+#endif
+
+      /* Transform */
+      r_trans.isat_np = ISAKMP_NEXT_NONE;
+      if (!out_struct(&r_trans, &isakmp_isakmp_transform_desc, &r_proposal_pbs, &r_trans_pbs))
+        passert(FALSE);
+
+      if (!out_raw(attr_start, attr_len, &r_trans_pbs, "attributes"))
+        passert(FALSE);
+      if (attr_start) pfree(attr_start);
+
+      close_output_pbs(&r_trans_pbs);
+      close_output_pbs(&r_proposal_pbs);
+      close_output_pbs(r_sa_pbs);
+    }
+  return NOTHING_WRONG;
+      }
+    }
+#endif
+
 }
 
 /* Parse the body of an IPsec SA Payload (i.e. Phase 2 / Quick Mode).
diff -ruN freeswan-1.5.orig/pluto/spdb.h freeswan-1.5/pluto/spdb.h
--- freeswan-1.5.orig/pluto/spdb.h	Sun Dec 12 19:40:57 1999
+++ freeswan-1.5/pluto/spdb.h	Thu Oct  5 07:05:59 2000
@@ -24,11 +24,32 @@
     u_int16_t val;
 };
 
+#ifdef OPENSSL
+typedef bool offer_fn(struct state *st);
+/* Addition for OpenSSL: we don't want to offer cipher suites */
+/* which we aren't capable of generating, so I added a function */
+/* parameter 'offer', which takes the state as a parameter, and */
+/* returns either TRUE or FALSE, depending on whether the cipher */
+/* suite is supportable. For instance, there's no point in */
+/* offering to sign things with a DSA signature key, if all you've */
+/* got is an RSA one. */
+/* NB: If the function pointer is set to NULL, it means offer the */
+/* cipher suite under all conditions. The downside to this is that */
+/* another parameter must be added to all the IPsec cipher transforms */
+/* which is always NULL. I suppose we could embed policy information */
+/* within that parameter, e.g. If a pair of endpoints must have */
+/* a particular cipher between them. Trouble is, that information is */
+/* present within ipsec.conf, to some extent -- nd */
+#endif
+
 /* transform */
 struct db_trans {
     u_int8_t transid;	/* Transform-Id */
     struct db_attr *attrs;	/* array */
     int attr_cnt;	/* number of elements */
+#ifdef OPENSSL
+    offer_fn *offer;
+#endif
 };
 
 /* proposal */
@@ -56,9 +77,12 @@
 };
 
 /* The oakley sadb is subscripted by a bitset with members
- * from POLICY_PSK and POLICY_RSASIG.
+ * from POLICY_PSK and POLICY_RSASIG/OPENSSL.
  */
 extern struct db_sa oakley_sadb[1 << 2];
+#ifdef OPENSSL
+extern struct db_sa oakley_sadb2[1 << 2];
+#endif
 
 /* The ipsec sadb is subscripted by a bitset with members
  * from POLICY_ENCRYPT, POLICY_AUTHENTICATE, POLICY_TUNNEL
diff -ruN freeswan-1.5.orig/pluto/state.c freeswan-1.5/pluto/state.c
--- freeswan-1.5.orig/pluto/state.c	Wed Jun 21 14:24:35 2000
+++ freeswan-1.5/pluto/state.c	Thu Oct  5 07:05:59 2000
@@ -324,6 +324,16 @@
     pfreeany(st->st_esp.our_keymat);
     pfreeany(st->st_esp.peer_keymat);
 
+#ifdef OPENSSL
+    /* Clean out the stuff for revised PK encryption mode */
+    pfreeany(st->st_ne_i.ptr);
+    memset(&st->st_ks_i, 0, sizeof(st->st_ks_i));
+    memset(st->st_ne_i_iv, 0, MAX_DIGEST_LEN);
+    pfreeany(st->st_ne_r.ptr);
+    memset(&st->st_ks_r, 0, sizeof(st->st_ks_r));
+    memset(st->st_ne_r_iv, 0, MAX_DIGEST_LEN);
+#endif
+
     pfree(st);
 }
 
diff -ruN freeswan-1.5.orig/pluto/state.h freeswan-1.5/pluto/state.h
--- freeswan-1.5.orig/pluto/state.h	Wed Jun 21 14:24:36 2000
+++ freeswan-1.5/pluto/state.h	Thu Oct  5 07:05:59 2000
@@ -64,6 +64,7 @@
 #endif
 };
 
+
 /* IPsec (Phase 2 / Quick Mode) transform and attributes
  * This is a flattened/decoded version of what is represented
  * by a Transaction Payload.  There may be one for AH and one
@@ -144,6 +145,16 @@
     chunk_t            st_gr;                  /* Responder public value */
     u_int8_t           st_rcookie[COOKIE_SIZE];/* Responder Cookie */
     chunk_t            st_nr;                  /* Nr nonce */
+
+#ifdef OPENSSL
+    /* key material for revised public key information */
+    u_int8_t           st_ne_i_iv[MAX_DIGEST_LEN];
+    chunk_t            st_ne_i;                /* key for initiator payloads */
+    keysched           st_ks_i;
+    u_int8_t           st_ne_r_iv[MAX_DIGEST_LEN];
+    chunk_t            st_ne_r;                /* key for responder payloads */
+    keysched           st_ks_r;
+#endif
 
 
   /* my stuff */
